package rytkonen.topi.maps;

import android.content.DialogInterface;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.graphics.Color;
import android.location.Location;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.ImageButton;

import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;
import android.database.DatabaseUtils;

import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationServices;



import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.Polyline;
import com.google.android.gms.maps.model.PolylineOptions;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;

import java.util.HashMap;


/**
 * An activity that displays a map showing the place at the device's current location.
 */
public class MapsActivity extends AppCompatActivity
        implements OnMapReadyCallback, GoogleMap.OnMarkerClickListener {

    private static final String TAG = MapsActivity.class.getSimpleName();
    private GoogleMap mMap;
    private CameraPosition mCameraPosition;

    // The entry points to the Places API.
    //private GeoDataClient mGeoDataClient;
    //private PlaceDetectionClient mPlaceDetectionClient;

    // The entry point to the Fused Location Provider.
    private FusedLocationProviderClient mFusedLocationProviderClient;

    // A default location (Kuopio, Finland) and default zoom to use when location permission is
    // not granted.
    //private final LatLng mDefaultLocation = new LatLng(62.89238, 27.67703);
    private static final int DEFAULT_ZOOM = 15;
    private static final int PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION = 1;
    private boolean mLocationPermissionGranted;

    // The geographical location where the device is currently located. That is, the last-known
    // location retrieved by the Fused Location Provider.
    private Location mLastKnownLocation;
    public int event;
    // Keys for storing activity state.
    private static final String KEY_CAMERA_POSITION = "camera_position";
    private static final String KEY_LOCATION = "location";

    private String[] mItems = {"Strawberry", "Blueberry", "Raspberry", "Penny Bun", "Chanterelle"};

    Database placesDB;

    //private HashMap markers = new HashMap();
    //TODO test
    static final float COORDINATE_OFFSET = 0.005f;
    HashMap<String, String> markerLocation = new HashMap<>();

    boolean recoverfromdb = true;
    boolean remove = false;
    boolean testi = true;


    //Buttons
    ImageButton imagebutton;
    ToggleButton removebutton;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        // Retrieve location and camera position from saved instance state.
        if (savedInstanceState != null) {
            mLastKnownLocation = savedInstanceState.getParcelable(KEY_LOCATION);
            mCameraPosition = savedInstanceState.getParcelable(KEY_CAMERA_POSITION);
        }

        placesDB = new Database(this);


        // Retrieve the content view that renders the map.
        setContentView(R.layout.activity_maps);


        // Construct a FusedLocationProviderClient.
        mFusedLocationProviderClient = LocationServices.getFusedLocationProviderClient(this);

        // Build the map.
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager()
                .findFragmentById(R.id.map);
        mapFragment.getMapAsync(this);


    }

    /**
     * Saves the state of the map when the activity is paused.
     */
    @Override
    protected void onSaveInstanceState(Bundle outState) {
        if (mMap != null) {
            outState.putParcelable(KEY_CAMERA_POSITION, mMap.getCameraPosition());
            outState.putParcelable(KEY_LOCATION, mLastKnownLocation);
            super.onSaveInstanceState(outState);
        }
    }

    /**
     * Sets up the options menu.
     *
     * @param menu The options menu.
     * @return Boolean.
     */
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.current_place_menu, menu);
        return true;
    }


    /**
     * Manipulates the map when it's available.
     * This callback is triggered when the map is ready to be used.
     */
    @Override
    public void onMapReady(GoogleMap map) {
        mMap = map;
        // Use a custom info window adapter to handle multiple lines of text in the
        // info window contents.
        mMap.setInfoWindowAdapter(new GoogleMap.InfoWindowAdapter() {

            @Override
            // Return null here, so that getInfoContents() is called next.
            public View getInfoWindow(Marker arg0) {
                return null;
            }

            @Override
            public View getInfoContents(Marker marker) {
                // Inflate the layouts for the info window, title and snippet.
                View infoWindow = getLayoutInflater().inflate(R.layout.custom_info_contents,
                        (FrameLayout) findViewById(R.id.map), false);

                TextView title = ((TextView) infoWindow.findViewById(R.id.title));
                title.setText(marker.getTitle());

                TextView snippet = ((TextView) infoWindow.findViewById(R.id.snippet));
                snippet.setText(marker.getSnippet());

                return infoWindow;
            }
        });

        // Prompt the user for permission.
        getLocationPermission();

        // Turn on the My Location layer and the related control on the map.
        updateLocationUI();

        // Get the current location of the device and set the position of the map.
        getDeviceLocation();

        // Load items from database and put them to map
        Log.i(TAG, "onMapReady: Adding items start");
        loadingitems();

        Log.i(TAG, "onMapReady: addBerry");
        // Adds a Button to add marker on the users location
        imagebutton = findViewById(R.id.addBerry);
        imagebutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Log.i(TAG, "onClick: Add tool");
                addBerryDialog();
                recoverfromdb = false;
            }
        });

        Log.i(TAG, "onMapReady: berryadded");
        Log.i(TAG, "onMapReady: removeberry");
        // Button to remove markers
        removebutton = findViewById(R.id.removeBerry);
        removebutton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(remove == false){
                    remove = true;
                    Log.i(TAG, "onClick: remove "+remove);
                }else{
                    remove=false;
                    Log.i(TAG, "onClick: remove "+remove );
                }
            }
        });
        Log.i(TAG, "onMapReady: berryremoved");


    }

    /**
     * Gets the current location of the device, and positions the map's camera.
     */
    private void getDeviceLocation() {
        /*
         * Get the best and most recent location of the device, which may be null in rare
         * cases when a location is not available.
         */
        try {
            if (mLocationPermissionGranted) {
                Task<Location> locationResult = mFusedLocationProviderClient.getLastLocation();
                locationResult.addOnCompleteListener(this, new OnCompleteListener<Location>() {
                    @Override
                    public void onComplete(@NonNull Task<Location> task) {
                        if (task.isSuccessful()) {
                            // Set the map's camera position to the current location of the device.
                            mLastKnownLocation = task.getResult();
                            mMap.moveCamera(CameraUpdateFactory.newLatLngZoom(
                                    new LatLng(mLastKnownLocation.getLatitude(),
                                            mLastKnownLocation.getLongitude()), DEFAULT_ZOOM));

                        } else {
                            Log.d(TAG, "Current location is null. Using defaults.");
                            Log.e(TAG, "Exception: %s", task.getException());

                            mMap.getUiSettings().setMyLocationButtonEnabled(false);
                        }
                    }
                });
            }
        } catch (SecurityException e) {
            Log.e("Exception: %s", e.getMessage());
        }
    }


    /**
     * Prompts the user for permission to use the device location.
     */
    private void getLocationPermission() {
        /*
         * Request location permission, so that we can get the location of the
         * device. The result of the permission request is handled by a callback,
         * onRequestPermissionsResult.
         */
        if (ContextCompat.checkSelfPermission(this.getApplicationContext(),
                android.Manifest.permission.ACCESS_FINE_LOCATION)
                == PackageManager.PERMISSION_GRANTED) {
            mLocationPermissionGranted = true;
        } else {
            ActivityCompat.requestPermissions(this,
                    new String[]{android.Manifest.permission.ACCESS_FINE_LOCATION},
                    PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION);
        }
    }

    /**
     * Handles the result of the request for location permissions.
     */
    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           @NonNull String permissions[],
                                           @NonNull int[] grantResults) {
        mLocationPermissionGranted = false;
        switch (requestCode) {
            case PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION: {
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0
                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    mLocationPermissionGranted = true;
                }
            }
        }
        updateLocationUI();
    }


    /**
     * Opens the dialog to add a new item marker to the map
     * sends the index of the option clicked to addBerryInfo.
     */
    private void addBerryDialog() {
        DialogInterface.OnClickListener listener = new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                addBerryInfo(which);
            }
        };
        AlertDialog dialog = new AlertDialog.Builder(this)
                .setTitle(R.string.menuItemNames)
                .setItems(mItems, listener)
                .show();
    }


    /**
     * When a placed marker is clicked on the map, this function will either delete the marker if delete tool is toggled on,
     * or display the google maps marker infobox.
     *
     * @param marker - Clicked marker object
     * @return
     */
    public boolean onMarkerClick(Marker marker) {
        Log.i(TAG, "onMarkerClick: remove" +remove);
        if(remove)
        {
            Log.i(TAG, "onMarkerClick: Remove start");
            Log.i(TAG, "onMarkerClick: lat " + (double)Math.round(marker.getPosition().latitude * 100000d) / 100000d+ " lng " +(double)Math.round(marker.getPosition().longitude * 100000d) / 100000d);

            Cursor temppi = placesDB.showData();


            Cursor tmp = placesDB.getid((double)Math.round(marker.getPosition().latitude * 100000d) / 100000d,(double)Math.round(marker.getPosition().longitude * 100000d) / 100000d);
            Log.i(TAG, "onMarkerClick: Delete start");
            String result = DatabaseUtils.dumpCursorToString(tmp);
            Log.i(TAG, "onMarkerClick: Result " +result);
            result = result.substring(result.indexOf("{"),result.indexOf("}"));
            Log.i(TAG, "onMarkerClick: Result " +result);
            result = result.replaceAll("\\D+","");
            Log.i(TAG, "onMarkerClick: Result " +result);
            Integer deledeRow = placesDB.deleteData(result);
            marker.remove();

            Log.i(TAG, "onMarkerClick: Remove end");
            return true;

        }

        //Shows items information to user
        else{
            Toast.makeText(this, marker.getTitle(),Toast.LENGTH_SHORT);
            LatLng Currentlatlng = new LatLng(mLastKnownLocation.getLatitude(),mLastKnownLocation.getLongitude());

            Polyline line = mMap.addPolyline(new PolylineOptions()
                        .add(Currentlatlng, marker.getPosition())
                        .width(5)
                        .color(Color.RED));
            }
            return false;


    }






    /**
     *  Allows the user to add a comment to the marker or cancel placing the marker.
     * @param item - index number of the selected item
     */
    //TODO collect berry info from user
    private void addBerryInfo(final int item)
    {
        AlertDialog.Builder popup = new AlertDialog.Builder(this);
        final EditText input = new EditText(this);
        popup.setView(input);
        popup.setTitle("Insert a comment for the marker");

        popup.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {
                input.setText("canceled");
            }
        });
        popup.setPositiveButton("OK", new DialogInterface.OnClickListener() {

            @Override
            public void onClick(DialogInterface dialog, int which) {
                //create marker and save it to database
                getDeviceLocation();
                Log.i(TAG, "onClick: lat " +mLastKnownLocation.getLatitude()+ "Lng " +mLastKnownLocation.getLongitude());
                addMarker(input.getText().toString(), item, mLastKnownLocation.getLatitude(), mLastKnownLocation.getLongitude());

            }
        });
        popup.show();

    }

    /**
     *  Adds a marker to the map and saves marker info to the database
     * @param comment - comment string left by the user
     * @param item - item index number
     */
    private void addMarker(String comment, int item, double lati, double longi)
    {

        Log.i(TAG, "addMarker: lat " +lati+"lng "+longi);
        double [] coords = coordinateForMarker(lati, longi);
        Log.i(TAG, "addMarker: " +coords[0] + " " + coords[1]);

        //Coordinates don't have a set accuracy max length so this takes the first 6 characters as this will be enough for this use
        Double latitude = (double)Math.round(lati * 100000d) / 100000d;
        Double longitude = (double)Math.round(longi * 100000d) / 100000d;


        //Checks whether the given coordinates already contain a marker, if they do
        // it will slightly increase the coordinates until it finds a free spot on the map
        Cursor tmp = placesDB.GetLatLng(lati,longi);

            for (int i = 0; tmp != null && tmp.getCount() > i; i++) {
                    lati += 0.00025;
                    longi += 0.00025;

            }

        LatLng user = new LatLng(lati, longi);

        Log.i(TAG, "addMarker: " +item + " " + latitude + " " + longitude + " " + comment);

        /**
         * add new entry to database
         */

        Log.i(TAG, "addMarker: Into switch");
        //Uses different marker icon based on the item variable
        selectPicture(user, item, lati,longi,comment);
        Log.i(TAG, "addMarker: Swicth END");
        //Sets an OnMarkerClickListener on the created marker
        mMap.setOnMarkerClickListener(this);
        // Sets markers tag as it's index number so that it's index number in database is more accessible
        // marker.setTag(markers.size());

        Log.i(TAG, "addMarker: ADD DB");
        Log.i(TAG, "addMarker: " + recoverfromdb);
        if (recoverfromdb == true && testi == false){
            Log.i(TAG, "addMarker: Flipping recoverfromdb " );
            recoverfromdb = false;
        }
        Log.i(TAG, "addMarker: " + recoverfromdb);
        //Boolean to determine if startup markerplacement from database has ended
        if(recoverfromdb == false || recoverfromdb == testi)
        {
            testi = false;
            Log.i(TAG, "addMarker: ADD ITEM DB");
            Log.i(TAG, "addMarker: LAT " +latitude);
            Log.i(TAG, "addMarker: LNG " +longitude);

            //adds the marker info to the database and to the arraylists that the program uses to handle existing markers
            boolean insertData = placesDB.addData(item, latitude, longitude, comment);
            Log.i(TAG, "addMarker: Was insertdata succesfull " +insertData);

            Cursor cursor = placesDB.showData();
            Log.i(TAG, "addMarker: "+DatabaseUtils.dumpCursorToString(cursor) );

            if(insertData == true)
            {
                Toast.makeText(MapsActivity.this, "Marker saved!", Toast.LENGTH_LONG).show();
            } else {
                Toast.makeText(MapsActivity.this, "Unable to save marker.", Toast.LENGTH_LONG).show();
            }
        }

    }

    /**
     * Loads items from database and puts them to map
     *
     */
    private void loadingitems() {

        Cursor tmp1 = placesDB.GetitemID();
        Cursor tmp2 = placesDB.GetLat();
        Cursor tmp3 = placesDB.GetLng();
        Cursor tmp4 = placesDB.GetComment();

        Log.i(TAG, "loadingitems: ITEM_ID" + DatabaseUtils.dumpCursorToString(tmp1));
        Log.i(TAG, "loadingitems: LAT" + DatabaseUtils.dumpCursorToString(tmp2));
        Log.i(TAG, "loadingitems: LNG" + DatabaseUtils.dumpCursorToString(tmp3));
        Log.i(TAG, "loadingitems: COMMENT" + DatabaseUtils.dumpCursorToString(tmp4));
        String itemID = DatabaseUtils.dumpCursorToString(tmp1);
        String lat = DatabaseUtils.dumpCursorToString(tmp2);
        String lng = DatabaseUtils.dumpCursorToString(tmp3);
        String comment = DatabaseUtils.dumpCursorToString(tmp4);

        if (tmp1.getCount() == 0) {
            return;
        }
        while (tmp1.moveToNext()) {

            String tmp_itemID = itemID.substring(itemID.indexOf("="),itemID.indexOf("}"));
            String tmp_lat = lat.substring(lat.indexOf("="),lat.indexOf("}"));
            String tmp_lng = lng.substring(lng.indexOf("="),lng.indexOf("}"));
            String tmp_comment = comment.substring(comment.indexOf("="),comment.indexOf("}"));
            tmp_lat = tmp_lat.substring(1);
            tmp_lng = tmp_lng.substring(1);
            tmp_comment = tmp_comment.substring(1);
            tmp_itemID = tmp_itemID.substring(1);
            Log.i(TAG, "loadingitems: tmp_itemID " +tmp_itemID);
            double tmp_lat_double = Double.valueOf(tmp_lat);
            double tmp_lng_double = Double.valueOf(tmp_lng);
            int tmp_ItemId_int = Integer.parseInt(tmp_itemID.trim());
            LatLng tmp_user =  new LatLng(tmp_lat_double,tmp_lng_double );

            selectPicture(tmp_user,tmp_ItemId_int,tmp_lat_double, tmp_lng_double,tmp_comment);
        }

    }


    /**
     *  Off set of cordinates
     * @param latitude
     * @param longitude
     * @return
     */
    //TODO this should off-set stacked markers so they won't get stacked
    private double[] coordinateForMarker(double latitude, double longitude) {
        Log.i(TAG, "coordinateForMarker: lat " + latitude+"lng "+longitude);
        double[] location = new double[2];
        Log.i(TAG, "coordinateForMarker: " +location[0] + " " + location[1]);
        //Log.i(TAG, "coordinateForMarker entered");
        Cursor tmp = placesDB.GetLatLng(latitude,longitude);
        //for (int i = 0; i <= mId.size(); i++) {
            for (int i = 0; tmp != null && tmp.getCount() > i ; i++) {
                location[0] = latitude - (i * COORDINATE_OFFSET );
                location[1] = longitude - (i * COORDINATE_OFFSET );

        }

        return location;
    }





    /**
     * Updates the map's UI settings based on whether the user has granted location permission.
     */
    private void updateLocationUI() {
        if (mMap == null) {
            return;
        }
        try {
            if (mLocationPermissionGranted) {
                mMap.setMyLocationEnabled(true);
                mMap.getUiSettings().setMyLocationButtonEnabled(true);

            } else {
                mMap.setMyLocationEnabled(false);
                mMap.getUiSettings().setMyLocationButtonEnabled(false);
                mLastKnownLocation = null;
                getLocationPermission();
            }
        } catch (SecurityException e)  {
            Log.e("Exception: %s", e.getMessage());
        }
    }

    /**
     * Selects picture for item and makes marker
     * @param user
     * @param item
     * @param lati
     * @param longi
     * @param comment
     */
    public void selectPicture(LatLng user, int item, double lati, double longi, String comment){

        Double latitude = (double)Math.round(lati * 100000d) / 100000d;
        Double longitude = (double)Math.round(longi * 100000d) / 100000d;
        switch (item)
        {

            case 0:Log.i(TAG, "addMarker: Into switch Strawberry");
                mMap.addMarker(new MarkerOptions()
                        .position(user)
                        .title("Latitude: " + latitude + "\n" + "Longitude: " + longitude + "\n" + comment)
                        .icon(BitmapDescriptorFactory.fromResource(R.drawable.strawberry)));

                Log.i(TAG, "addMarker: Into switch Strawberry end");
                break;

            case 1: mMap.addMarker(new MarkerOptions()
                    .position(user)
                    .title("Latitude: " + latitude + "\n" + "Longitude: " + longitude + "\n" + comment)
                    .icon(BitmapDescriptorFactory.fromResource(R.drawable.blueberry)));

                break;

            case 2: mMap.addMarker(new MarkerOptions()
                    .position(user)
                    .title("Latitude: " + latitude + "\n" + "Longitude: " + longitude + "\n" + comment)
                    .icon(BitmapDescriptorFactory.fromResource(R.drawable.raspberry)));
                break;

            case 3: mMap.addMarker(new MarkerOptions()
                    .position(user)
                    .title("Latitude: " + latitude + "\n" + "Longitude: " + longitude + "\n" + comment)
                    .icon(BitmapDescriptorFactory.fromResource(R.drawable.penny_bun)));
                break;

            case 4: mMap.addMarker(new MarkerOptions()
                    .position(user)
                    .title("Latitude: " + latitude + "\n" + "Longitude: " + longitude + "\n" + comment)
                    .icon(BitmapDescriptorFactory.fromResource(R.drawable.chanterelle)));
                break;


        }
    }

}